class Pioneer
{
  int x, y;             // Position
  int velX, velY;     // Velocity
  
  boolean landed;       // Whether the ship has landed
  
  float randomValue;    // Holds a random value
  
  int savedTime;           // Interval at which this Person moves (milliseconds)
  int totalTime;        // Current time in milliseconds
  
  Pioneer(int _x, int _y)
  {
    x = _x;
    y = _y;
    velX = int(random(-4,4));
    velY = int(random(-4,4));
    
    landed = false;
    
    totalTime = 250; 
    savedTime = millis();
  }  // end of constructor
  
  
  void timer()
  {
    int passedTime = millis() - savedTime;
    if (passedTime > totalTime)
    {
      move();
      savedTime = millis();
    }  // timer end
  }  // move() end  
  
  
  void display()
  {
    fill(255,255,0);
    rect(x, y, 1, 1);
  }
  
  void move()
  {
    int loc = x + y * width;
    int nextLoc = (x+velX) + (y+velY)*width;
    loc = constrain(loc, 0, tiles.length-1);
    nextLoc = constrain(nextLoc, 0, tiles.length-1);
    tiles[loc].timesUsed += 20;
    
    if (landed == false)
    { 
      // If pioneer reaches a good spot, settle
      if (tiles[loc].mountainAdj == true || tiles[loc].waterAdj == true || tiles[nextLoc].terrainType == 4 || tiles[nextLoc].terrainType == 2 || tiles[nextLoc].terrainType == 0)
      {
        tiles[loc].terrainType = 4;
        tiles[loc].settlementLevel++;
        for(int i = 0; i < 3; i++)
        {
          PVector spawn = new PVector( x-random(velX*2),y-random(velY*2) );
          dudes.add(  new Person( int(spawn.x),int(spawn.y), x, y )  );
        }
        // Move pioneer off screen
        x = -1000;
        y = -1000;
        velX = 0;
        velY = 0;
        landed = true;
      }
      x += velX;
      y += velY;
    }
  }  // end of move()


}  // end of Class
