class Slider {
  PVector location, slider_location;
  float lowest_value, highest_value, current_value;
  float output_value;
  float size;
  String label;
  boolean  mouse_over;
  
  Slider(float current_value_, float lowest_value_, float highest_value_, float x_, float y_, float size_, String label_) {
    location = new PVector(x_, y_);
    lowest_value = lowest_value_;
    highest_value = highest_value_;
    current_value = current_value_;
    size = size_;
    label = label_;
    slider_location = new PVector( map(current_value, lowest_value, highest_value, location.x-size/2, location.x+size/2),
                                   location.y );
  }
  
  
  void update() {
    // See if mouse is over this slider
    if (mouseX >= slider_location.x-5 && mouseX <= slider_location.x+5 && mouseY >= slider_location.y-10 && mouseY <= slider_location.y+10) mouse_over = true;
    else mouse_over = false;
    
    // Constrain the slider to stay within the bar
    slider_location.x = constrain(slider_location.x, location.x-size/2, location.x+size/2);
    
    output_value = map( slider_location.x, location.x - size/2, location.x+size/2, lowest_value, highest_value);
  }
  
  
  void display() {
    // Display bar
    line(location.x-size/2, location.y, location.x+size/2, location.y);
    line(location.x-size/2, location.y+10, location.x-size/2, location.y-10);
    line(location.x+size/2, location.y+10, location.x+size/2, location.y-10);
    
    // Display slider
    rectMode(CENTER);
    rect(slider_location.x, slider_location.y, 10, 20);
    rectMode(CORNER);
    
    fill(255);
    textSize(10);
    text(label, location.x, location.y+10);
  }
  
}
