// Still to do:
//  - Add buttons for zoom and to confirm picture choice/terrain changes
//  - Make it so you can't the camera too far out and lose the map

ArrayList pioneers;     // Pioneeeersssees
ArrayList dudes;

Boat boat;

Slider seaLevelSlider;
Slider landHeightSlider;

FadingText instructions;

Tile[] tiles;           // An array of tile objects

int state = 0;          // State of program

int mouseTimer = 0;     // Timer to make sure the mouse only clicks once
boolean mouseClicked;   // Boolean that activates when mouse is clicked, deactivates after set ammount of millis

PImage sourceImg;       // Base image used to generate the map
PImage terrainMap;      // The map image to be generated
boolean invert;         // Will reverse land/water
boolean image_chosen;

color backgroundColor;

//float avgBright;        // Average brightness of the image's pixels

float waterThreshold = 226;  // Threshold below which brightness of image becomes water
float landThreshold  = 253;  // Threshold below which brightness of image becomes land (above becomes mountains)

float s = 1;       // Scaling for errything
float transX = 0;  // Translation for everything
float transY = 0;  // Also that

int settlementThreshold;  // Number of people required to increase the settlement level of a tile.

Alarm personMoveTimer;  // A timer for 'turns'

float time; // For perlin noise


void setup()
{
  size(800, 600);
  frameRate(30);
  background(128);
  frame.setResizable(true);
    
  instructions = new FadingText("Click to confirm!");
  
  noSmooth();
  
  loadPixels();
      
  selectInput("Choose an image to convert into terrain:", "fileSelected");
  
  settlementThreshold = 3;
  
  backgroundColor = color(65, 70, 210);
  
  personMoveTimer = new Alarm(250);
  
  // Create an array list of Dude objects    
  dudes = new ArrayList();
  
  // Create an array list of Pioneer objects
  pioneers = new ArrayList();
  
}


void draw()
{
  loadPixels();
  
  noStroke();
  if (s > 1)
  {
    float tx = width/2 + transX*s;
    float ty = height/2 + transY*s;
//    ty = constrain(ty, -height*s, 0);
    translate(tx, ty);
    scale(s);
    translate(0, 0);
  } else {
    transX = -width/2;
    transY = -height/2;
  }

  // State 0: Taking the picture
  if (state == 0)
  {    
    if (image_chosen) {
      image(sourceImg, 0, 0);
      textSize(20);
      if (!mousePressed) text("click to confirm image!", width/2, height/2);
    } else {
      // Display choose image message
      fill( map(noise(time), 0, 1, 0, 255),
            map(noise(time+9383), 0, 1, 0, 255),
            map(noise(time-483286), 0, 1, 0, 255)     );
      textSize(  map( noise(time+338383), 0, 1, 5, 100) );
      textAlign(CENTER);
      text("Choose an image!", width/2, map( noise(time-2929200), 0, 1, 0, height) );
      fill(255);
      textSize(30);
      text("Welcome! This program will generate a terrain map from an image file of your choice! Your generated terrain will then be colonized by hordes of ship-bound pixels, eager to exploit all of your image's precious natural resources. They will found cities, explore, farm, mine and build roads. Then, they'll spawn offspring to do it all over again! Watch as your lush virgin wilderness is converted into an barely-habitable industrial hellscape, just like in real life! Note: performance drops significantly as image size increases.", 20, 20, width-20, height-20);
    }
  } // state 0 end (see 'cont_mouse' tab for next actions)


  // State 1: Converting the picture into the terrain map, and adjusting water-level / land height.
  if (state == 1)
  {
    // Create new image from frame when mouse was pressed
    sourceImg = loadImage("source.jpg");

    // Generate new terrain image from source image
    terrainMap = generateTerrain(sourceImg, waterThreshold, landThreshold);
    
    // Display the terrain map
    image(terrainMap, 0, 0);
    
    fill(255);
    textSize(10);
    text("Modify your terrain!", width/2, height*0.27);
    text("Then, click anywhere to continue!", width/2, height*0.37);
    
    // Display slider bars
    stroke(255);
    fill(105, 214, 87);
    seaLevelSlider.update();
    seaLevelSlider.display();
    fill(231, 178, 17);
    landHeightSlider.update();
    landHeightSlider.display();
    
    
    // Update thresholds
    waterThreshold = seaLevelSlider.output_value;
    landThreshold = landHeightSlider.output_value;
  } // state 1 end (see cont_Mouse for next actions)


  // State 2: Finalizing the map image and filling the array of Tile objects
  if (state == 2)
  { 
    analyzeTerrain();
    
    // Create boat
    boat = new Boat();
        
    println("State 3");
    state = 3;
  } // state 2 end
  
  
  // State 3: Where everything happens
  if (state == 3)
  {
    background(backgroundColor);
    
    image(terrainMap, 0, 0);
    
    personMoveTimer.run();
    
    boat.move();
    boat.display();
    
    // Display the bottom layer
    for (int i = 0; i < pixels.length; i++) {
        tiles[i].belowPeopleDisplay();
    }  // for i = 0 end
    
    // Display the dude layer
    if (dudes.size() > 0)
    {
      for (int i = 0; i < dudes.size(); i++)
      {
        Dude d = (Dude) dudes.get(i);
        if (d.disable == false) {
          if (personMoveTimer.finished) d.move();
          d.display();
        } else {
          d = null;
        }
      }
    }
    
    if (personMoveTimer.finished) personMoveTimer = new Alarm(100);
    
    // Display pioneers
    if (pioneers.size() > 0)
    {
      for (int i = 0; i < pioneers.size(); i++)
      {
        Pioneer p = (Pioneer) pioneers.get(i);
        p.timer();
        p.display();
        if (p.landed) p = null;
      }
    }
    
    // Display the top layer
    for (int i = 0; i < pixels.length; i++) {
        tiles[i].abovePeopleDisplay();
    }  // for i = 0 end
    
    fill(255);
    textSize(10);
    textAlign(LEFT);
    text("X: zoom in ~~~ Z: zoom out ~~~ Click: move camera", 10, height - 3);
    
  }  // state 3 end
  
  time += 0.005;
  
} // end draw()
